/*  
 *  Created by Michael Feiri on Thu Jan 03 2002.
 *  Copyright (c) 2002-2004 Michael Feiri. All rights reserved.
 *
 */


/*
 * IMPORTANT
 *
 * The way festog works can be modified by changing the includes below.
 * Festog is preconfigured to search up to and including nogr19+11. In order to
 * be able to search for rulers with more marks you have to provide larger
 * "choose" tables.
 *
 */








/*
 * NUMWORDS 1 ->  ((1*32*2)+1)+(NUMDIFFS*2) =  65+64 = 129
 * NUMWORDS 2 ->  ((2*32*2)+1)+(NUMDIFFS*2) = 129+64 = 193
 * NUMWORDS 3 ->  ((3*32*2)+1)+(NUMDIFFS*2) = 193+64 = 257
 * NUMWORDS 4 ->  ((4*32*2)+1)+(NUMDIFFS*2) = 257+64 = 321
 * NUMWORDS 5 ->  ((5*32*2)+1)+(NUMDIFFS*2) = 321+64 = 385
 * NUMWORDS 6 ->  ((6*32*2)+1)+(NUMDIFFS*2) = 385+64 = 449
 */

#define NUMWORDS 4  /* look at the table above to see what value enable which lengths */
#define NUMDIFFS 40	/* size of the array where we can verify the golombness of rulers */
                    /* e.g. with NUMDIFFS 32 we can safely validate rulers up to 64
                     * units longer than waht NUMWORDS alone would allow */

#include <stdio.h>      /* printf() */
#include <stdlib.h>     /* atoi() */
#include <inttypes.h>   /* unit??_t,<stdint.h> */


//#include "finalizeV4.h"
//#include "choose/chooseV3_16_24_imp_uint16.h"
#include "choose/chooseV3_16_19_imp_uint16.h"
//#include "choose/chooseV3_16_16_uint8.h"
//#include "choose/chooseV3_16_14_uint8.h"
//#include "choose/chooseV3_16_12.h"
//#include "choose/chooseV3_16_8.h"
#include "bitmaps32.h" 	/* BITMAP */
//#include "bitmaps32_ppc.h" 	/* BITMAP */
//#include "bitmaps32_vec.h" 	/* BITMAP */
//#include "bitmaps64.h" 	/* BITMAP */
//#include "bitmaps64_ppc.h" 	/* BITMAP */
//#include "bitmapsvec.h" 	/* BITMAP */
#include "OGRconstraints_nofin.h" 	/* LIMITS */
//#include "OGRconstraints.h" 	/* LIMITS */


#define MAXMARKS CHOOSEMARKS+1
//#define MAXMARKS 32	/* depth of stacks -> we can place up to 31 marks (plus the "0" mark means OGR-32) */

void foundone(int maxlength, int maxmarks,int count[]) {

                int i,j;
                char diffs[NUMDIFFS]={0}; // can store diffs up to and including 32
                
                for (i=1; i <= maxmarks; i++) {
                    for (j=0; j<i; j++) {
                        int diff = count[i]-count[j];
                        /* only need to check (NUMWORDS*32)<diff<=(maxlength/2) (real bitmaps, principle 1) */
                        if (((diff*2)<=maxlength) && (diff>(NUMWORDS*32))) {
                            diff -= (NUMWORDS*32)+1; /* we want to start saving at position 0 rather than 1 */
                            if (diffs[diff]!=0) { /*goto stay;*/ return; }
                            diffs[diff] = 1;
                        }
                    }
                }
                
                
                #if defined(STORE_DIST) // e.g.: OGRchoose
                
                STORE_DIST;
                RESET_LIMITS;
                //break;//goto up;
                
                #else	// default
                
                printf("{%3d",count[maxmarks]);
                if ((count[maxmarks]-count[maxmarks-1])>count[1]) {
                    for(i=1; i<=maxmarks; i++ ) printf(",%d",count[i]-count[i-1]); printf("},\n");
                } else {
                    for(i=maxmarks; i>0; i-- ) printf(",%d",count[i]-count[i-1]); printf("},\n");
                } fflush(0);
                
                #endif
}


static uint64_t halfTweakedGARSP(const int maxmarks, int maxlength, int progress[], const int lockeddiffs) {
//static uint32_t halfTweakedGARSP(const int maxmarks, int maxlength, int progress[]) {

    int depth=1;		/* current mark we are placing corresponds to the D in the PDF */
    signed int count[MAXMARKS]={0};	/* current ruler length (e.g. LENGTH[])*/
    uint64_t nodes=0;

    SETUP_BITMAPS
    SETUP_LIMITS
    INTITIALIZE_BITMAPS
    #if defined(MODIFY_DIST)
    MODIFY_DIST;
    #endif

    if ((maxlength/2)-(NUMWORDS*32) > NUMDIFFS) { /* sanity check -> size of bitmaps */
        printf("Your NUMWORDS(%d) including the overflow space in NUMDIFFS(%d) are too short\n",NUMWORDS,NUMDIFFS);
        printf("Your current limit is ((NUMWORDS*32*2)+1)+(NUMDIFFS*2)=%d\n",(((NUMWORDS*32*2)+1)+(NUMDIFFS*2)));
        printf("You should use more bitmaps (NUMWORDS) or enlarge the overflow test (NUMDIFFS)\n");
        return 0;
    } else if (maxmarks>=MAXMARKS) { /* sanity check -> limit calculation and depth of stack */
        // MAXMARKS is now defined by CHOOSEMARKS
        printf("You can only search up to OGR-%d but you requested OGR-%d\n",MAXMARKS,maxmarks+1);
        printf("Please provide a larger chooseV3 table\n");
        return 0;
    }


    // VERIFY GOLOMBNESS, LIMIT BREAKING AND DO OTHER SANITY CHECKS OF PROGRESS[]
    // WARNING: RESUMING ADDS ONE (or two) NODE TO THE NODECOUNT
    do {
        int s = progress[depth-1];
        // Execute this ONCE but put it in a loop to catch situations when we
        // would intercept requests to go deeper (the value of s stays the same)
        //for (;s<=progress[depth-1];s++) {
        CALCULATE_LIMITS;
        //} if (s!=progress[depth-1]) {printf("ERROR in resume\n"); return 0;}

        nodes++;
        if (!progress[depth-1]>0) { break; }

        for (count[depth]+=s;s>=32;s-=32) {
            CLLR_WORD_BITMAPS
        }
        if (s>0) {
            CLLR_XX_BITMAPS
        }
        
//printf("resume %d versus limit %d\n",count[depth],limit[depth]);
//printf("%d\n",lockeddiffs);
        
        {DEEPER_BITMAPS}
        count[depth+1] = count[depth]; // pass on our current length
        depth++;			   // one level deeper

    } while (progress[depth-2]>0);
     
    if (nodes==0) { //CALCULATE_LIMITS cancelled right away and thus we can skip the rest
        #if defined(STORE_DIST) 
            return maxlength;
        #else
            return nodes;
        #endif
    } else { nodes=0; }










    /* search through the search space **** */
    do {
        
        while (1) {

            //stay:
            SET_NEXT_MARK

            if (depth == (maxmarks)) {
                foundone(maxlength, maxmarks,count);
                continue;
            }
                
            DEEPER_BITMAPS

            count[depth+1] = count[depth]; // pass on our current length
            depth++;			   // one level deeper

            CALCULATE_LIMITS;
            
            nodes++;
			/*
            // Going deeper succeeded
            if (depth == 4) {
                int i;
                printf("{%3d",count[3]);
                for(i=1; i<=3; i++ ) printf(",%d",count[i]-count[i-1]); printf("},\n");
                break;
            }
            */
        }

        depth--;

        UP_BITMAPS;
    } while (depth>lockeddiffs);
    //} while (depth>0);
















#if defined(STORE_DIST) 
    return maxlength;
#else
    return nodes;
#endif
}

#ifndef AS_MODULE

#include <sys/time.h>
#include <sys/resource.h>

double dtime()
{
    struct rusage rusage;
    double q;

    getrusage(RUSAGE_SELF,&rusage);

    q = (double)(rusage.ru_utime.tv_sec);
    q = q + (double)(rusage.ru_utime.tv_usec) * 1.0e-06;
	
    return q;
}

int main (int argc, const char * argv[])
{
    double starttime, benchtime;
    uint64_t nodes;
	int i,numberofmarks,lengthuptoinc, lockeddiffs=0;
    int resume[MAXMARKS] = {0};
    //int resume[MAXMARKS] = {6,9,30,14,10,11,0}; //dnetc benchmark data for OGR25
    //int resume[MAXMARKS] = {17,20,0}; // search (16,199+2) and use this data to test finalize

	if (argc<3) {
		printf("\n\napp <marks> <maxlength> [fixeddiffs [diff1 [diff2 [...]]]]\n\n");
/*		printf("You must specify at least the number of marks\n");
		printf("and the length up to which you want to search\n");
		printf("E.g.: '<app> 16 177' will search golomb rulers\n");
		printf("with 16 marks (15diffs) and a length up to (and\n");
		printf("including) 177 units\n");
		printf("\n");
		printf("Optionally you can provide an initial set of diffs");
		printf("as a staring point. If you use this feature you\n");
		printf("must also specify when the search should stop. You\n");
		printf("do this by indicating how many (if any) of the diffs\n");
		printf("you provided should be locked. (You can not lock more\n");
		printf("diffs than you specify as your starting point)\n");
		printf("E.g.:\n");
		printf("'app 16 177 3 2 5 9' will search rulers of the form\n");
		printf("16/2-5-9-*-*-*-*-*-*-*-*-*-*-*\n");
		printf("\n");
		printf("'app 16 177 2 2 5 9' will start at \n");
		printf("16/2-5-9-*-*-*-*-*-*-*-*-*-*-* and search rulers\n");
		printf("that start with 2-5 and have a third diff that is >=9\n");
		printf("\n");
		printf("E.g.: 'app 16 177 0 2 5 9' will start at 2-5-9 and search\n");
		printf("the entire remaining searchspace\n\n");
*/		exit(1);
    } else {
		numberofmarks=atoi(argv[1]);
		lengthuptoinc=atoi(argv[2]);
	}
	if (argc>3) {
        if (atoi(argv[3])<=(argc-4)) {
            lockeddiffs=atoi(argv[3]);
        } else {
            printf("ERROR: You cannot lock more diffs than");
            printf("you provided as the starting point!\n");
        }
    }
    for(i=4;i<argc;i++){
        resume[i-4]=atoi(argv[i]);
    } resume[argc-4]=0;
    

    printf("config: %d bitmaps, %d numdiffs, %d maxmarks, %d maxlength\n",
    NUMWORDS,NUMDIFFS,MAXMARKS, (((NUMWORDS*32*2)+1)+(NUMDIFFS*2)));
    printf("constraints: %d choosemarks, %d choosebits, KTEST%d\n",CHOOSEMARKS, CHOOSEBITS, KTEST);
    printf("build date: %s %s\n",__DATE__, __TIME__);
    printf("invoked with:"); for(i=1;i<argc;i++) printf(" %d",atoi(argv[i])); printf("\n");

    starttime = dtime();

    // TODO: write back the progess status into the resume array
    nodes = halfTweakedGARSP(numberofmarks-1,lengthuptoinc,resume,lockeddiffs);
    //nodes = halfTweakedGARSP(numberofmarks-1,lengthuptoinc,resume);
    
    benchtime = dtime() - starttime;

    printf("Nodes per second = %.3f ( %llu nodes/ %.3f seconds)\n",nodes/benchtime,nodes,benchtime);
    
    return 0;
}

#endif
