/*
 * Here is the music. These are the speed critical routine. Optimize these as
 * good as you can and provide replacements by overwiting the respective macros.
 */


/*
 * Find the location of the first zero bit, starting left. You have 3 options:
 * loop over all bits, use lookuptables or utilize spezial instructions
 */
#ifndef LOOKUP_FIRSTBLANK
static const char lookup_first_blank_8bit_inv[256] =  {
	9,8,7,7,6,6,6,6,5,5,5,5,5,5,5,5,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
    3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,
    2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
    2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
static inline int LOOKUP_FIRSTBLANK(uint32_t x) {
	unsigned int a = (x>=0xffff0000?(x>=0xffffff00?0:8):(x>=0xff000000?16:24));
	return lookup_first_blank_8bit_inv[(~x>>a)]+(24-a);
}
#endif


/*
 * divide between 0...FFFFFFFD and FFFFFFFE,FFFFFFFF in order to properly
 * handle shifting by 32 bits and to facilitate LOOKUP_FIRSTBLANK
 */
 
#ifndef SET_NEXT_MARK
#define SET_NEXT_MARK                                                   \
if (comp0 < 0xfffffffe) {                                               \
    int s = LOOKUP_FIRSTBLANK( comp0 );                                 \
        if ((count[depth] += s) > limit[depth]) {break; /*goto up;*/}   \
        else {                                                          \
            CLLR_XX_BITMAPS;                                            \
        }                                                               \
} else { /* s>=32 */                                                    \
    if ((count[depth] += 32) > limit[depth]) {break; /*goto up;*/}      \
    else {                                                              \
        uint32_t temp = comp0;                                          \
        CLLR_WORD_BITMAPS;                                              \
        if (temp == 0xffffffff) {continue; /*goto stay;*/}              \
    }                                                                   \
}
#endif





#ifndef GET_DIST_CHOOSEBITS
#if ((CHOOSEBITS<=32)&&(CHOOSEBITS>0))
#define GET_DIST_CHOOSEBITS ((uint32_t)(dist0>>(32-CHOOSEBITS)))
#endif
#endif

#ifndef GET_DIST_FINALIZEBITS
#if ((FINALIZEBITS<=32)&&(FINALIZEBITS>0))
#define GET_DIST_FINALIZEBITS ((uint32_t)(dist0>>(32-FINALIZEBITS)))
#endif
#endif



#if (NUMWORDS==1)

#ifndef SETUP_BITMAPS
#define SETUP_BITMAPS           \
uint32_t lista0[MAXMARKS];      \
uint32_t compa0[MAXMARKS];      \
uint32_t newbit=1;
#endif

#ifndef INTITIALIZE_BITMAPS
#define INTITIALIZE_BITMAPS					\
uint32_t dist0=0;							\
uint32_t list0=0;							\
uint32_t comp0=0;							\
lista0[depth]=0;							\
compa0[depth]=0;
#endif

#ifndef CLLR_XX_BITMAPS
#define CLLR_XX_BITMAPS						\
int ss=32-s;                                \
list0 = (list0 >> s) | (newbit << ss);      \
comp0 = (comp0 << s);
#endif

#ifndef CLLR_WORD_BITMAPS
#define CLLR_WORD_BITMAPS						\
comp0 = 0;                                  \
list0 = newbit;                             \
newbit = 0;
#endif

#ifndef DEEPER_BITMAPS
#define DEEPER_BITMAPS						\
compa0[depth]=comp0;                       \
lista0[depth]=list0;                       \
dist0 |= list0;                             \
comp0 |= dist0;                             \
newbit=1;
#endif

#ifndef UP_BITMAPS
#define UP_BITMAPS							\
comp0=compa0[depth];						\
list0=lista0[depth];						\
dist0= dist0 & ~list0;						\
newbit=0;
#endif



#elif (NUMWORDS==2)

#ifndef SETUP_BITMAPS
#define SETUP_BITMAPS           \
uint32_t lista0[MAXMARKS];      \
uint32_t lista1[MAXMARKS];      \
uint32_t compa0[MAXMARKS];      \
uint32_t compa1[MAXMARKS];      \
uint32_t newbit=1;
#endif

#ifndef INTITIALIZE_BITMAPS
#define INTITIALIZE_BITMAPS					\
uint32_t dist0=0;							\
uint32_t dist1=0;							\
uint32_t list0=0;							\
uint32_t list1=0;							\
uint32_t comp0=0;							\
uint32_t comp1=0;							\
lista0[depth]=0;							\
lista1[depth]=0;							\
compa0[depth]=0;							\
compa1[depth]=0;
#endif

#ifndef CLLR_XX_BITMAPS
#define CLLR_XX_BITMAPS						\
int ss=32-s;                                \
list1 = (list1 >> s) | (list0 << ss);       \
comp0 = (comp0 << s) | (comp1 >> ss);       \
list0 = (list0 >> s) | (newbit << ss);      \
comp1 = (comp1 << s);
#endif

#ifndef CLLR_WORD_BITMAPS
#define CLLR_WORD_BITMAPS						\
comp0 = comp1;                              \
comp1 = 0;                                  \
list1 = list0;                              \
list0 = newbit;                             \
newbit = 0;
#endif

#ifndef DEEPER_BITMAPS
#define DEEPER_BITMAPS						\
compa0[depth]=comp0;                       \
compa1[depth]=comp1;                       \
lista0[depth]=list0;                       \
lista1[depth]=list1;                       \
dist0 |= list0;                             \
dist1 |= list1;                             \
comp0 |= dist0;                             \
comp1 |= dist1;                             \
newbit=1;
#endif

#ifndef UP_BITMAPS
#define UP_BITMAPS							\
comp0=compa0[depth];						\
comp1=compa1[depth];						\
list0=lista0[depth];						\
list1=lista1[depth];						\
dist0= dist0 & ~list0;						\
dist1= dist1 & ~list1;						\
newbit=0;
#endif



#elif (NUMWORDS==3)

#ifndef SETUP_BITMAPS
#define SETUP_BITMAPS           \
uint32_t lista0[MAXMARKS];      \
uint32_t lista1[MAXMARKS];      \
uint32_t lista2[MAXMARKS];      \
uint32_t compa0[MAXMARKS];      \
uint32_t compa1[MAXMARKS];      \
uint32_t compa2[MAXMARKS];      \
uint32_t newbit=1;
#endif

#ifndef INTITIALIZE_BITMAPS
#define INTITIALIZE_BITMAPS					\
uint32_t dist0=0;							\
uint32_t dist1=0;							\
uint32_t dist2=0;							\
uint32_t list0=0;							\
uint32_t list1=0;							\
uint32_t list2=0;							\
uint32_t comp0=0;							\
uint32_t comp1=0;							\
uint32_t comp2=0;							\
lista0[depth]=0;							\
lista1[depth]=0;							\
lista2[depth]=0;							\
compa0[depth]=0;							\
compa1[depth]=0;							\
compa2[depth]=0;
#endif

#ifndef CLLR_XX_BITMAPS
#define CLLR_XX_BITMAPS						\
int ss=32-s;                                \
list2 = (list2 >> s) | (list1 << ss);       \
comp0 = (comp0 << s) | (comp1 >> ss);       \
list1 = (list1 >> s) | (list0 << ss);       \
comp1 = (comp1 << s) | (comp2 >> ss);       \
list0 = (list0 >> s) | (newbit << ss);      \
comp2 = (comp2 << s);
#endif

#ifndef CLLR_WORD_BITMAPS
#define CLLR_WORD_BITMAPS						\
comp0 = comp1;                              \
comp1 = comp2;                              \
comp2 = 0;                                  \
list2 = list1;                              \
list1 = list0;                              \
list0 = newbit;                             \
newbit = 0;
#endif

#ifndef DEEPER_BITMAPS
#define DEEPER_BITMAPS						\
compa0[depth]=comp0;                       \
compa1[depth]=comp1;                       \
compa2[depth]=comp2;                       \
lista0[depth]=list0;                       \
lista1[depth]=list1;                       \
lista2[depth]=list2;                       \
dist0 |= list0;                             \
dist1 |= list1;                             \
dist2 |= list2;                             \
comp0 |= dist0;                             \
comp1 |= dist1;                             \
comp2 |= dist2;                             \
newbit=1;
#endif

#ifndef UP_BITMAPS
#define UP_BITMAPS							\
comp0=compa0[depth];						\
comp1=compa1[depth];						\
comp2=compa2[depth];						\
list0=lista0[depth];						\
list1=lista1[depth];						\
list2=lista2[depth];						\
dist0= dist0 & ~list0;						\
dist1= dist1 & ~list1;						\
dist2= dist2 & ~list2;						\
newbit=0;
#endif



#elif (NUMWORDS==4)

#ifndef SETUP_BITMAPS
#define SETUP_BITMAPS           \
uint32_t lista0[MAXMARKS];      \
uint32_t lista1[MAXMARKS];      \
uint32_t lista2[MAXMARKS];      \
uint32_t lista3[MAXMARKS];      \
uint32_t compa0[MAXMARKS];      \
uint32_t compa1[MAXMARKS];      \
uint32_t compa2[MAXMARKS];      \
uint32_t compa3[MAXMARKS];      \
uint32_t newbit=1;
#endif

#ifndef INTITIALIZE_BITMAPS
#define INTITIALIZE_BITMAPS					\
uint32_t dist0=0;							\
uint32_t dist1=0;							\
uint32_t dist2=0;							\
uint32_t dist3=0;							\
uint32_t list0=0;							\
uint32_t list1=0;							\
uint32_t list2=0;							\
uint32_t list3=0;							\
uint32_t comp0=0;							\
uint32_t comp1=0;							\
uint32_t comp2=0;							\
uint32_t comp3=0;							\
lista0[depth]=0;							\
lista1[depth]=0;							\
lista2[depth]=0;							\
lista3[depth]=0;							\
compa0[depth]=0;							\
compa1[depth]=0;							\
compa2[depth]=0;							\
compa3[depth]=0;
#endif

#ifndef CLLR_XX_BITMAPS
#define CLLR_XX_BITMAPS						\
int ss=32-s;                                \
list3 = (list3 >> s) | (list2 << ss);       \
comp0 = (comp0 << s) | (comp1 >> ss);       \
list2 = (list2 >> s) | (list1 << ss);       \
comp1 = (comp1 << s) | (comp2 >> ss);       \
list1 = (list1 >> s) | (list0 << ss);       \
comp2 = (comp2 << s) | (comp3 >> ss);       \
list0 = (list0 >> s) | (newbit << ss);      \
comp3 = (comp3 << s);
#endif

#ifndef CLLR_WORD_BITMAPS
#define CLLR_WORD_BITMAPS						\
comp0 = comp1;                              \
comp1 = comp2;                              \
comp2 = comp3;                              \
comp3 = 0;                                  \
list3 = list2;                              \
list2 = list1;                              \
list1 = list0;                              \
list0 = newbit;                             \
newbit = 0;
#endif

#ifndef DEEPER_BITMAPS
#define DEEPER_BITMAPS						\
compa0[depth]=comp0;                       \
compa1[depth]=comp1;                       \
compa2[depth]=comp2;                       \
compa3[depth]=comp3;                       \
lista0[depth]=list0;                       \
lista1[depth]=list1;                       \
lista2[depth]=list2;                       \
lista3[depth]=list3;                       \
dist0 |= list0;                             \
dist1 |= list1;                             \
dist2 |= list2;                             \
dist3 |= list3;                             \
comp0 |= dist0;                             \
comp1 |= dist1;                             \
comp2 |= dist2;                             \
comp3 |= dist3;                             \
newbit=1;
#endif

#ifndef UP_BITMAPS
#define UP_BITMAPS							\
comp0=compa0[depth];						\
comp1=compa1[depth];						\
comp2=compa2[depth];						\
comp3=compa3[depth];						\
list0=lista0[depth];						\
list1=lista1[depth];						\
list2=lista2[depth];						\
list3=lista3[depth];						\
dist0= dist0 & ~list0;						\
dist1= dist1 & ~list1;						\
dist2= dist2 & ~list2;						\
dist3= dist3 & ~list3;						\
newbit=0;
#endif



#elif (NUMWORDS==5)

#ifndef SETUP_BITMAPS
#define SETUP_BITMAPS           \
uint32_t lista0[MAXMARKS];      \
uint32_t lista1[MAXMARKS];      \
uint32_t lista2[MAXMARKS];      \
uint32_t lista3[MAXMARKS];      \
uint32_t lista4[MAXMARKS];      \
uint32_t compa0[MAXMARKS];      \
uint32_t compa1[MAXMARKS];      \
uint32_t compa2[MAXMARKS];      \
uint32_t compa3[MAXMARKS];      \
uint32_t compa4[MAXMARKS];      \
uint32_t newbit=1;
#endif

#ifndef INTITIALIZE_BITMAPS
#define INTITIALIZE_BITMAPS					\
uint32_t dist0=0;							\
uint32_t dist1=0;							\
uint32_t dist2=0;							\
uint32_t dist3=0;							\
uint32_t dist4=0;							\
uint32_t list0=0;							\
uint32_t list1=0;							\
uint32_t list2=0;							\
uint32_t list3=0;							\
uint32_t list4=0;							\
uint32_t comp0=0;							\
uint32_t comp1=0;							\
uint32_t comp2=0;							\
uint32_t comp3=0;							\
uint32_t comp4=0;							\
lista0[depth]=0;							\
lista1[depth]=0;							\
lista2[depth]=0;							\
lista3[depth]=0;							\
lista4[depth]=0;							\
compa0[depth]=0;							\
compa1[depth]=0;							\
compa2[depth]=0;							\
compa3[depth]=0;							\
compa4[depth]=0;
#endif

#ifndef CLLR_XX_BITMAPS
#define CLLR_XX_BITMAPS						\
int ss=32-s;                                \
list4 = (list4 >> s) | (list3 << ss);       \
comp0 = (comp0 << s) | (comp1 >> ss);       \
list3 = (list3 >> s) | (list2 << ss);       \
comp1 = (comp1 << s) | (comp2 >> ss);       \
list2 = (list2 >> s) | (list1 << ss);       \
comp2 = (comp2 << s) | (comp3 >> ss);       \
list1 = (list1 >> s) | (list0 << ss);       \
comp3 = (comp3 << s) | (comp4 >> ss);       \
list0 = (list0 >> s) | (newbit << ss);      \
comp4 = (comp4 << s);
#endif

#ifndef CLLR_WORD_BITMAPS
#define CLLR_WORD_BITMAPS						\
comp0 = comp1;                              \
comp1 = comp2;                              \
comp2 = comp3;                              \
comp3 = comp4;                              \
comp4 = 0;                                  \
list4 = list3;                              \
list3 = list2;                              \
list2 = list1;                              \
list1 = list0;                              \
list0 = newbit;                             \
newbit = 0;
#endif

#ifndef DEEPER_BITMAPS
#define DEEPER_BITMAPS						\
compa0[depth]=comp0;                       \
compa1[depth]=comp1;                       \
compa2[depth]=comp2;                       \
compa3[depth]=comp3;                       \
compa4[depth]=comp4;                       \
lista0[depth]=list0;                       \
lista1[depth]=list1;                       \
lista2[depth]=list2;                       \
lista3[depth]=list3;                       \
lista4[depth]=list4;                       \
dist0 |= list0;                             \
dist1 |= list1;                             \
dist2 |= list2;                             \
dist3 |= list3;                             \
dist4 |= list4;                             \
comp0 |= dist0;                             \
comp1 |= dist1;                             \
comp2 |= dist2;                             \
comp3 |= dist3;                             \
comp4 |= dist4;                             \
newbit=1;
#endif

#ifndef UP_BITMAPS
#define UP_BITMAPS							\
comp0=compa0[depth];						\
comp1=compa1[depth];						\
comp2=compa2[depth];						\
comp3=compa3[depth];						\
comp4=compa4[depth];						\
list0=lista0[depth];						\
list1=lista1[depth];						\
list2=lista2[depth];						\
list3=lista3[depth];						\
list4=lista4[depth];						\
dist0= dist0 & ~list0;						\
dist1= dist1 & ~list1;						\
dist2= dist2 & ~list2;						\
dist3= dist3 & ~list3;						\
dist4= dist4 & ~list4;						\
newbit=0;
#endif



#elif (NUMWORDS==6)

#ifndef SETUP_BITMAPS
#define SETUP_BITMAPS           \
uint32_t lista0[MAXMARKS];      \
uint32_t lista1[MAXMARKS];      \
uint32_t lista2[MAXMARKS];      \
uint32_t lista3[MAXMARKS];      \
uint32_t lista4[MAXMARKS];      \
uint32_t lista5[MAXMARKS];      \
uint32_t compa0[MAXMARKS];      \
uint32_t compa1[MAXMARKS];      \
uint32_t compa2[MAXMARKS];      \
uint32_t compa3[MAXMARKS];      \
uint32_t compa4[MAXMARKS];      \
uint32_t compa5[MAXMARKS];      \
uint32_t newbit=1;
#endif

#ifndef INTITIALIZE_BITMAPS
#define INTITIALIZE_BITMAPS					\
uint32_t dist0=0;							\
uint32_t dist1=0;							\
uint32_t dist2=0;							\
uint32_t dist3=0;							\
uint32_t dist4=0;							\
uint32_t dist5=0;							\
uint32_t list0=0;							\
uint32_t list1=0;							\
uint32_t list2=0;							\
uint32_t list3=0;							\
uint32_t list4=0;							\
uint32_t list5=0;							\
uint32_t comp0=0;							\
uint32_t comp1=0;							\
uint32_t comp2=0;							\
uint32_t comp3=0;							\
uint32_t comp4=0;							\
uint32_t comp5=0;							\
lista0[depth]=0;							\
lista1[depth]=0;							\
lista2[depth]=0;							\
lista3[depth]=0;							\
lista4[depth]=0;							\
lista5[depth]=0;							\
compa0[depth]=0;							\
compa1[depth]=0;							\
compa2[depth]=0;							\
compa3[depth]=0;							\
compa4[depth]=0;							\
compa5[depth]=0;
#endif

#ifndef CLLR_XX_BITMAPS
#define CLLR_XX_BITMAPS						\
int ss=32-s;                                \
list5 = (list5 >> s) | (list4 << ss);       \
comp0 = (comp0 << s) | (comp1 >> ss);       \
list4 = (list4 >> s) | (list3 << ss);       \
comp1 = (comp1 << s) | (comp2 >> ss);       \
list3 = (list3 >> s) | (list2 << ss);       \
comp2 = (comp2 << s) | (comp3 >> ss);       \
list2 = (list2 >> s) | (list1 << ss);       \
comp3 = (comp3 << s) | (comp4 >> ss);       \
list1 = (list1 >> s) | (list0 << ss);       \
comp4 = (comp4 << s) | (comp5 >> ss);       \
list0 = (list0 >> s) | (newbit << ss);      \
comp5 = (comp5 << s);
#endif

#ifndef CLLR_WORD_BITMAPS
#define CLLR_WORD_BITMAPS						\
comp0 = comp1;                              \
comp1 = comp2;                              \
comp2 = comp3;                              \
comp3 = comp4;                              \
comp4 = comp5;                              \
comp5 = 0;                                  \
list5 = list4;                              \
list4 = list3;                              \
list3 = list2;                              \
list2 = list1;                              \
list1 = list0;                              \
list0 = newbit;                             \
newbit = 0;
#endif

#ifndef DEEPER_BITMAPS
#define DEEPER_BITMAPS						\
compa0[depth]=comp0;                       \
compa1[depth]=comp1;                       \
compa2[depth]=comp2;                       \
compa3[depth]=comp3;                       \
compa4[depth]=comp4;                       \
compa5[depth]=comp5;                       \
lista0[depth]=list0;                       \
lista1[depth]=list1;                       \
lista2[depth]=list2;                       \
lista3[depth]=list3;                       \
lista4[depth]=list4;                       \
lista5[depth]=list5;                       \
dist0 |= list0;                             \
dist1 |= list1;                             \
dist2 |= list2;                             \
dist3 |= list3;                             \
dist4 |= list4;                             \
dist5 |= list5;                             \
comp0 |= dist0;                             \
comp1 |= dist1;                             \
comp2 |= dist2;                             \
comp3 |= dist3;                             \
comp4 |= dist4;                             \
comp5 |= dist5;                             \
newbit=1;
#endif

#ifndef UP_BITMAPS
#define UP_BITMAPS							\
comp0=compa0[depth];						\
comp1=compa1[depth];						\
comp2=compa2[depth];						\
comp3=compa3[depth];						\
comp4=compa4[depth];						\
comp5=compa5[depth];						\
list0=lista0[depth];						\
list1=lista1[depth];						\
list2=lista2[depth];						\
list3=lista3[depth];						\
list4=lista4[depth];						\
list5=lista5[depth];						\
dist0= dist0 & ~list0;						\
dist1= dist1 & ~list1;						\
dist2= dist2 & ~list2;						\
dist3= dist3 & ~list3;						\
dist4= dist4 & ~list4;						\
dist5= dist5 & ~list5;						\
newbit=0;
#endif



#else

#error no bitmaps defined in bitmaps32.h for your configuration of NUMWORDS

#endif

