/*
 *  bitmaps32_ppc.h
 *
 *  Some macros that provide optimized versions of subroutines
 *  found in bitmaps32.h
 *
 */

// works best when compiled with -Os -> 20.5 MNodes/sec using 5 bitmaps on 1.25GHz G4+

#ifndef LOOKUP_FIRSTBLANK
#if defined(__GNUC__)
#define LOOKUP_FIRSTBLANK(c0) ({int t; __asm__ volatile ("cntlzw %0,%1" : "=r"(t) : "0" (~c0)); ++t;})
#endif
#endif


#ifndef CLLR_XX_BITMAPS
#if (NUMWORDS==2)

#define CLLR_XX_BITMAPS							                \
uint32_t temp0, temp1;						                    \
int ss=32-s;							                        \
temp0 = (list0 << ss); list0 = (list0 >> s) | (newbit << ss);   \
list1 = (list1 >> s) | temp0;		                            \
temp1 = (comp1 >> ss); comp1 = (comp1 << s);		            \
comp0 = (comp0 << s) | temp1;

#elif (NUMWORDS==3)

#define CLLR_XX_BITMAPS							                \
uint32_t temp0, temp1;						                    \
int ss=32-s;							                        \
temp0 = (list0 << ss); list0 = (list0 >> s) | (newbit << ss);   \
temp1 = (list1 << ss); list1 = (list1 >> s) | temp0;	        \
list2 = (list2 >> s) | temp1;		                            \
temp0 = (comp2 >> ss); comp2 = (comp2 << s);		            \
temp1 = (comp1 >> ss); comp1 = (comp1 << s) | temp0;		    \
comp0 = (comp0 << s) | temp1;

#elif (NUMWORDS==4)

#define CLLR_XX_BITMAPS                                         \
uint32_t temp0, temp1;                                          \
int ss=32-s;                                                    \
temp0 = (list0 << ss); list0 = (list0 >> s) | (newbit << ss);   \
temp1 = (list1 << ss); list1 = (list1 >> s) | temp0;            \
temp0 = (list2 << ss); list2 = (list2 >> s) | temp1;            \
list3 = (list3 >> s) | temp0;                                   \
temp1 = (comp3 >> ss); comp3 = (comp3 << s);                    \
temp0 = (comp2 >> ss); comp2 = (comp2 << s) | temp1;            \
temp1 = (comp1 >> ss); comp1 = (comp1 << s) | temp0;            \
comp0 = (comp0 << s) | temp1;

#elif (NUMWORDS==5)

#define CLLR_XX_BITMAPS							                \
uint32_t temp0, temp1;							                \
int ss=32-s;								                    \
temp0 = (list0 << ss); list0 = (list0 >> s) | (newbit << ss);	\
temp1 = (list1 << ss); list1 = (list1 >> s) | temp0;			\
temp0 = (list2 << ss); list2 = (list2 >> s) | temp1;			\
temp1 = (list3 << ss); list3 = (list3 >> s) | temp0;			\
list4 = (list4 >> s) | temp1;		                            \
temp0 = (comp4 >> ss); comp4 = (comp4 << s);		            \
temp1 = (comp3 >> ss); comp3 = (comp3 << s) | temp0;			\
temp0 = (comp2 >> ss); comp2 = (comp2 << s) | temp1;			\
temp1 = (comp1 >> ss); comp1 = (comp1 << s) | temp0;			\
comp0 = (comp0 << s) | temp1;

#elif (NUMWORDS==6)

#define CLLR_XX_BITMAPS							                \
uint32_t temp0, temp1;							                \
int ss=32-s;								                    \
temp0 = (list0 << ss); list0 = (list0 >> s) | (newbit << ss);	\
temp1 = (list1 << ss); list1 = (list1 >> s) | temp0;			\
temp0 = (list2 << ss); list2 = (list2 >> s) | temp1;			\
temp1 = (list3 << ss); list3 = (list3 >> s) | temp0;			\
temp0 = (list4 << ss); list4 = (list4 >> s) | temp1;			\
list5 = (list5 >> s) | temp0;		                            \
temp1 = (comp5 >> ss); comp5 = (comp5 << s);		            \
temp0 = (comp4 >> ss); comp4 = (comp4 << s) | temp1;			\
temp1 = (comp3 >> ss); comp3 = (comp3 << s) | temp0;			\
temp0 = (comp2 >> ss); comp2 = (comp2 << s) | temp1;			\
temp1 = (comp1 >> ss); comp1 = (comp1 << s) | temp0;			\
comp0 = (comp0 << s) | temp1;

#endif
#endif

#include "bitmaps32.h"
