/*
 * Here is the music. These are the speed critical routine. Optimize these as
 * good as you can and provide replacements by overwiting the respective macros.
 */

// This seems to perform better than regular 32bit implementations when using NUMWORDS >= 5
// the first 32bit of each bitmap are in a scalar registers, the rest is placed in vector registers

// works best when compiled with -O3 -> 27.8MNodes/sec using 5 bitmaps on 1.25GHz G4+

#if ((NUMWORDS%4)==1)
 #define FIRSTELEMENT 0
#elif ((NUMWORDS%4)==2)
 #define FIRSTELEMENT 3
#elif ((NUMWORDS%4)==3)
 #define FIRSTELEMENT 2
#elif ((NUMWORDS%4)==0)
 #define FIRSTELEMENT 1
#endif

#define VEC_TO_INT(v,n) (combo_t.VC = (v), combo_t.C[n])



#if ((NUMWORDS==2) || (NUMWORDS==3) || (NUMWORDS==4) || (NUMWORDS==5))


#ifndef SETUP_BITMAPS
#define SETUP_BITMAPS					                    \
union {								                        \
    uint32_t C[4];			                                \
    vector unsigned int VC;                                 \
} combo_t;								                    \
vector unsigned int lista0v[MAXMARKS];                      \
vector unsigned int compa0v[MAXMARKS];                      \
vector unsigned int ZEROS = (vector unsigned int) (0,0,0,0);\
vector unsigned int ONES = vec_nor(ZEROS,ZEROS);            \
uint32_t lista0[MAXMARKS];      \
uint32_t compa0[MAXMARKS];      \
uint32_t newbit=1;
#endif

#ifndef INTITIALIZE_BITMAPS
#define INTITIALIZE_BITMAPS			        \
lista0v[depth] = ZEROS;   				    \
compa0v[depth] = ZEROS;                      \
vector unsigned int list0v = ZEROS;          \
vector unsigned int dist0v = ZEROS;          \
vector unsigned int comp0v = ZEROS;          \
uint32_t dist0=0;							\
uint32_t list0=0;							\
uint32_t comp0=0;							\
lista0[depth]=0;							\
compa0[depth]=0;
#endif

#ifndef CLLR_XX_BITMAPS
#define CLLR_XX_BITMAPS                             \
vector unsigned int Vs,Vm,Vss;                      \
int ss=32-s;                                        \
uint32_t comp1 = VEC_TO_INT(comp0v,FIRSTELEMENT);              \
combo_t.C[3] = s;                                   \
Vs = vec_splat(combo_t.VC,3);                       \
Vm = vec_sl(ONES,Vs);                               \
Vss = vec_sub(ZEROS,Vs);                            \
combo_t.VC = vec_xor(comp0v,comp0v);                \
combo_t.C[FIRSTELEMENT] = (list0 << ss);                       \
comp0v = vec_rl(comp0v,Vs);                             \
comp0v = vec_sel(vec_sld(comp0v,ZEROS,4),comp0v,Vm);    \
list0v = vec_sel(vec_sld(ZEROS,list0v,12),list0v,Vm);   \
list0v = vec_rl(list0v,Vss);                            \
list0v = vec_or(list0v,combo_t.VC);                     \
list0 = (list0 >> s) | (newbit << ss);                  \
comp0 = (comp0 << s) | (comp1 >> ss);
#endif


/* DAS GEHT NUR WENN vReg voll ausgenutzt, scheint aber nicht schneller
#ifndef CLLR_WORD_BITMAPS
#define CLLR_WORD_BITMAPS						\
comp0 = VEC_TO_INT(comp0v,FIRSTELEMENT);                   \
combo_t.C[3] = list0;                           \
comp0v = vec_sld(comp0v, ZEROS, 4);             \
list0v = vec_sld(combo_t.VC, list0v, 12);        \
list0 = newbit;                                 \
newbit = 0;
#endif
*/


#ifndef CLLR_WORD_BITMAPS
#define CLLR_WORD_BITMAPS						\
comp0 = VEC_TO_INT(comp0v,FIRSTELEMENT);                   \
combo_t.VC = vec_xor(comp0v,comp0v);                \
combo_t.C[FIRSTELEMENT] = list0;                           \
comp0v = vec_sld(comp0v, ZEROS, 4);             \
list0v = vec_sld(ZEROS,list0v,12);   \
list0v = vec_or(list0v,combo_t.VC);                     \
list0 = newbit;                                 \
newbit = 0;
#endif


#ifndef DEEPER_BITMAPS
#define DEEPER_BITMAPS					\
compa0v[depth] = comp0v;                  \
lista0v[depth] = list0v;					\
dist0v = vec_or(list0v,dist0v);			\
comp0v = vec_or(dist0v,comp0v);            \
compa0[depth]=comp0;                       \
lista0[depth]=list0;                       \
dist0 |= list0;                             \
comp0 |= dist0;                             \
newbit=1;
#endif

#ifndef UP_BITMAPS
#define UP_BITMAPS                      \
list0v = lista0v[depth];					\
comp0v = compa0v[depth];			     	\
dist0v = vec_andc(dist0v, list0v);							\
list0=lista0[depth];						\
comp0=compa0[depth];						\
dist0= dist0 & ~list0;						\
newbit=0;
#endif


#elif ((NUMWORDS==6) || (NUMWORDS==7) || (NUMWORDS==8) || (NUMWORDS==9))


#ifndef SETUP_BITMAPS
#define SETUP_BITMAPS					                    \
union {								                        \
    uint32_t C[4];			                                \
    vector unsigned int VC;                                 \
} combo_t;								                    \
vector unsigned int lista0v[MAXMARKS];                      \
vector unsigned int lista1v[MAXMARKS];                      \
vector unsigned int compa0v[MAXMARKS];                      \
vector unsigned int compa1v[MAXMARKS];                      \
vector unsigned int ZEROS = (vector unsigned int) (0,0,0,0);\
vector unsigned int ONES = vec_nor(ZEROS,ZEROS);            \
uint32_t lista0[MAXMARKS];      \
uint32_t compa0[MAXMARKS];      \
uint32_t newbit=1;
#endif

#ifndef INTITIALIZE_BITMAPS
#define INTITIALIZE_BITMAPS			        \
lista0v[depth] = ZEROS;   				    \
compa0v[depth] = ZEROS;                      \
lista1v[depth] = ZEROS;   				    \
compa1v[depth] = ZEROS;                      \
vector unsigned int list0v = ZEROS;          \
vector unsigned int dist0v = ZEROS;          \
vector unsigned int comp0v = ZEROS;          \
vector unsigned int list1v = ZEROS;          \
vector unsigned int dist1v = ZEROS;          \
vector unsigned int comp1v = ZEROS;          \
uint32_t dist0=0;							\
uint32_t list0=0;							\
uint32_t comp0=0;							\
lista0[depth]=0;							\
compa0[depth]=0;
#endif

#ifndef CLLR_XX_BITMAPS
#define CLLR_XX_BITMAPS                             \
vector unsigned int Vs,Vm,Vss;                      \
int ss=32-s;                                        \
uint32_t comp1 = VEC_TO_INT(comp0v,FIRSTELEMENT);              \
combo_t.C[3] = s;                                   \
Vs = vec_splat(combo_t.VC,3);                       \
Vm = vec_sl(ONES,Vs);                               \
Vss = vec_sub(ZEROS,Vs);                            \
combo_t.VC = vec_xor(comp0v,comp0v);                \
combo_t.C[FIRSTELEMENT] = (list0 << ss);                       \
comp0v = vec_rl(comp0v,Vs);                             \
comp1v = vec_rl(comp1v,Vs);                             \
comp0v = vec_sel(vec_sld(comp0v,comp1v,4),comp0v,Vm);    \
comp1v = vec_sel(vec_sld(comp1v,ZEROS,4),comp1v,Vm);   \
list1v = vec_sel(vec_sld(list0v,list1v,12),list1v,Vm);  \
list0v = vec_sel(vec_sld(ZEROS,list0v,12),list0v,Vm);   \
list1v = vec_rl(list1v,Vss);                          \
list0v = vec_rl(list0v,Vss);                            \
list0v = vec_or(list0v,combo_t.VC);                     \
list0 = (list0 >> s) | (newbit << ss);                  \
comp0 = (comp0 << s) | (comp1 >> ss);
#endif


#ifndef CLLR_WORD_BITMAPS
#define CLLR_WORD_BITMAPS						\
comp0 = VEC_TO_INT(comp0v,FIRSTELEMENT);                   \
combo_t.VC = vec_xor(comp0v,comp0v);                \
combo_t.C[FIRSTELEMENT] = list0;                           \
comp0v = vec_sld(comp0v, comp1v, 4);             \
comp1v = vec_sld(comp1v, ZEROS, 4);		\
list1v = vec_sld(list0v, list1v, 12);		\
list0v = vec_sld(ZEROS,list0v,12);   \
list0v = vec_or(list0v,combo_t.VC);                     \
list0 = newbit;                                 \
newbit = 0;
#endif


#ifndef DEEPER_BITMAPS
#define DEEPER_BITMAPS					\
compa0v[depth] = comp0v;                  \
lista0v[depth] = list0v;					\
compa1v[depth] = comp1v;                  \
lista1v[depth] = list1v;					\
dist0v = vec_or(list0v,dist0v);			\
comp0v = vec_or(dist0v,comp0v);            \
dist1v = vec_or(list1v,dist1v);			\
comp1v = vec_or(dist1v,comp1v);            \
compa0[depth]=comp0;                       \
lista0[depth]=list0;                       \
dist0 |= list0;                             \
comp0 |= dist0;                             \
newbit=1;
#endif

#ifndef UP_BITMAPS
#define UP_BITMAPS                      \
list0v = lista0v[depth];					\
comp0v = compa0v[depth];			     	\
list1v = lista1v[depth];					\
comp1v = compa1v[depth];			     	\
dist0v = vec_andc(dist0v, list0v);							\
dist1v = vec_andc(dist1v, list1v);							\
list0=lista0[depth];						\
comp0=compa0[depth];						\
dist0= dist0 & ~list0;						\
newbit=0;
#endif


#endif


#include "bitmaps32_ppc.h"
